#region Copyright Syncfusion Inc. 2001 - 2016
// Copyright Syncfusion Inc. 2001 - 2016. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EditingDemo
{
    public class Country
    {
        private int id;
        public int CountryId
        {
            get { return id; }
            set { id = value; }
        }

        private string cityCollectionName;
        public string CityName
        {
            get { return cityCollectionName; }
            set { cityCollectionName = value; }
        }
    }
    public class EmployeeRepository
    {
        private static Random random = new Random(123123);
        /// <summary>
        /// Initializes a new instance of the <see cref="ViewModel"/> class.
        /// </summary>
        public EmployeeRepository()
        {
            this.EmployeeDetails = this.CreateGenericPersonData(3, 2);
            ////CityCollection = new ObservableCollection<Country>()            
            ////{
            ////    //new Country() { CountryId = "USA", CityName = "Adelaide" },
            ////    //new Country() { CountryId = "Japan", CityName = "Tokyo" },
            ////    //new Country() { CountryId = "US", CityName = "San Francisco" },
            ////    //new Country() { CountryId = "Spain", CityName = "Barcelona" },
            ////    //new Country() { CountryId = "SouthAfrica", CityName = "Durban" },
            ////    //new Country() { CountryId ="Australian" , CityName = "Canberra" },
            ////    //new Country() { CountryId = "Australia", CityName = "Sydney" },
            ////    //new Country() { CountryId = "UK", CityName = "Manchester" },
            ////    //new Country() { CountryId = "England", CityName = "London" },
            ////    //new Country() { CountryId = "ES", CityName = "Liverpool" },
            ////    //new Country() { CountryId = "German", CityName = "Zurich" },
            ////    //new Country() { CountryId = "Spain", CityName = "Madrid" },
            ////    //new Country() { CountryId = "Italy", CityName = "Rome" },
            ////    //new Country() { CountryId = "Glamorgan", CityName = "Cardiff" },
            ////    //new Country() { CountryId = "US", CityName = "NewYork" },
            ////    //new Country() { CountryId = "US", CityName = "Birmingham" },

            ////    new Country() { CountryId = 0, CityName = "Adelaide" },
            ////    new Country() { CountryId = 1, CityName = "Tokyo" },
            ////    new Country() { CountryId = 2, CityName = "San Francisco" },
            ////    new Country() { CountryId = 3, CityName = "Barcelona" },
            ////    new Country() { CountryId = 4, CityName = "Durban" },
            ////    new Country() { CountryId = 5 , CityName = "Canberra" },
            ////    new Country() { CountryId = 6, CityName = "Sydney" },
            ////    new Country() { CountryId = 7, CityName = "Manchester" },
            ////    new Country() { CountryId = 8, CityName = "London" },
            ////    new Country() { CountryId = 9, CityName = "Liverpool" },
            ////    new Country() { CountryId = 10, CityName = "Zurich" },
            ////    new Country() { CountryId = 11, CityName = "Madrid" },
            ////    new Country() { CountryId = 12, CityName = "Rome" },
            ////    new Country() { CountryId = 13, CityName = "Cardiff" },
            ////    new Country() { CountryId = 14, CityName = "NewYork" },
            ////    new Country() { CountryId = 15, CityName = "Birmingham" },
            ////};
        }

        private ObservableCollection<Employee> _EmployeeDetails;

        /// <summary>
        /// Gets or sets the person details.
        /// </summary>
        /// <value>The person details.</value>
        public ObservableCollection<Employee> EmployeeDetails
        {
            get { return _EmployeeDetails; }
            set { _EmployeeDetails = value; }
        }

        private ObservableCollection<Country> cityCollection;

        public ObservableCollection<Country> CityCollection
        {
            get { return cityCollection; }
            set { cityCollection = value; }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ViewModel"/> class.
        /// </summary>
        /// <param name="count">The count.</param>
        /// <param name="maxGenerations">The max generations.</param>
        public EmployeeRepository(int count, int maxGenerations)
        {
            CreateGenericPersonData(count, maxGenerations);
        }

        /// <summary>
        /// Creates the child list.
        /// </summary>
        /// <param name="count">The count.</param>
        /// <param name="maxGenerations">The max generations.</param>
        /// <param name="lastName">The last name.</param>
        /// <returns></returns>
        public ObservableCollection<Employee> CreateChildList(int count, int maxGenerations, string lastName)
        {
            ObservableCollection<Employee> _children = new ObservableCollection<Employee>();
            if (count > 0 && maxGenerations > 0)
            {
                _children = CreateGenericPersonData(count, maxGenerations - 1);
                //foreach (Employee p in _children)
                //    p.LastName = lastName;
            }
            return _children;
        }

        /// <summary>
        /// Creates the generic person data.
        /// </summary>
        /// <param name="count">The count.</param>
        /// <param name="maxGenerations">The max generations.</param>
        /// <returns></returns>
        public ObservableCollection<Employee> CreateGenericPersonData(int count, int maxGenerations)
        {
            var personList = new ObservableCollection<Employee>();
            if (count > 0)
            {
                for (int i = 0; i < 4; i++)
                {
                    var lastname = names2[random.Next(names2.GetLength(0))];
                    personList.Add(new Employee()
                    {
                        FirstName = names1[random.Next(names1.GetLength(0))],
                        LastName = lastname,
                        Children = this.CreateChildList(count, (int)Math.Max(0, maxGenerations - 1), lastname),
                        Salary = 30000d + random.Next(9) * 10000,
                        CityDescription = citydes[i],
                        CityId = city[i],
                        DOB = GenerateRandomDate().Date,
                        IsAvailable = random.Next(100) % 3 == 0 ? true : false,
                        ContactNumber = random.Next(999111, 999119).ToString(),
                        Hike = hike[random.Next(hike.GetLength(0))],

                    });
                }
            }
            return personList;
        }

        /// <summary>
        /// Generates the random date.
        /// </summary>
        /// <returns></returns>
        private DateTime GenerateRandomDate()
        {
            int randInt = random.Next(4000);
            return DateTime.Now.AddDays(-8000 + randInt);
        }

        string[] citydes = new string[]
       {
            "Argentina",
            "Austria",
            "Belgium",
            "Brazil",
            "Canada",
            "Denmark",
            "Finland",
            "France",
            "Germany",
            "Ireland",
            "Italy",
            "Mexico"
   };

        string[] city = new string[]
        {
            "Buenos Aires",
            "Graz",
            "Bruxelles",
            "Campinas",
            "Tsawassen",
            "rhus",
            "Helsinki",
            "Lyon",
            "Berlin",
            "Cork",
            "Torino",
            "Mxico D.F."
    };
        #region Array Collection

        private static string[] names1 = new string[]{
            "George","John","Thomas","James","Andrew","Martin","William","Zachary",
            "Millard","Franklin","Abraham","Ulysses","Rutherford","Chester","Grover","Benjamin",
            "Theodore","Woodrow","Warren","Calvin","Herbert","Franklin","Harry","Dwight","Lyndon",
            "Richard","Gerald","Jimmy","Ronald","George","Bill", "Barack", "Warner","Peter", "Larry"
        };
        private static string[] names2 = new string[]{
             "Washington","Adams","Jefferson","Madison","Monroe","Jackson","Van Buren","Harrison","Tyler",
             "Polk","Taylor","Fillmore","Pierce","Buchanan","Lincoln","Johnson","Grant","Hayes","Garfield",
             "Arthur","Cleveland","Harrison","McKinley","Roosevelt","Taft","Wilson","Harding","Coolidge",
             "Hoover","Truman","Eisenhower","Kennedy","Johnson","Nixon","Ford","Carter","Reagan","Bush",
             "Clinton","Bush","Obama","Smith","Jones","Stogner"
        };
        private static string[] color = new string[]{
            "Red", "Blue", "Brown", "Unknown"
        };

        private static double[] hike = new double[]{
            6,5.5,10,10.2,11, 15, 6.8,14,7.7,9.5,8.2,16
        };
        #endregion
    }
}
